# Bloop v1.0.0-M7

This is the seventh milestone of Bloop. This release focuses on improving the user experience and
fixes several important bugs.

## Release highlights

#### Autocompletion for Bash and zsh

In order to make Bloop more enjoyable to use, we added command line completions for Bloop,
compatible with Bash and zsh. They are automatically installed when using Homebrew. For other
platforms, our [installation instructions][installation instructions] explain how to install the completion.

For details about the work, see [#353][#353].

<img src="https://i.imgur.com/YOnJ8sf.gif" />

#### Simpler installation

[@valencik][@valencik] contributed a fix to our installation script, in order to make it compatible with both
Python 2 and 3. Thanks to his changes, the installation script now runs smoothly on all
configurations. The work happened in [#343][#343]. Thanks [@valencik][@valencik] :tada: !

#### Improved sbt-bloop

sbt-bloop used to define a task called `installBloop`, which has been renamed to `bloopInstall`. The
reason for the renaming is to improve the discoverability of this task. For more details, see the
discussion in [#341][#341] and [#346][#346].

#### Better file watching

In some cases, the file watcher would trigger an action more than once for a single change. As a
result, we would sometimes get wrong results for compilation. The file watcher has been fixed so
that this doesn't happen again.

Support for listener has also been added, so that bloop knows when a client has disconnected and can
stop watching files. For more details, see [#345][#345].

#### Fixes and improvements to the task engine

After a compilation failure, for instance, Bloop would still try (and fail) to run a project. This
problem has been fixed by improvements to how different tasks are combined within Bloop. See [#347][#347]
for all the details.

## Install Bloop

To install the latest version of Bloop, you can either use Homebrew:

```sh
$ brew install scalacenter/bloop/bloop
```

For other systems, you can download and the installation script below, or copy paste the following
line in your terminal:

```
$ curl -L https://github.com/scalacenter/bloop/releases/download/v1.0.0-M7/install.py | python
```

[#341]: https://github.com/scalacenter/bloop/pull/341
[#343]: https://github.com/scalacenter/bloop/pull/343
[#345]: https://github.com/scalacenter/bloop/pull/345
[#346]: https://github.com/scalacenter/bloop/pull/346
[#347]: https://github.com/scalacenter/bloop/pull/347
[#353]: https://github.com/scalacenter/bloop/pull/353
[@valencik]: https://github.com/valencik
[installation instructions]: https://scalacenter.github.io/bloop/docs/installation
