# bloop `v.1.4.2`

Bloop v1.4.2 is a bugfix release, addressing some issues of previous Bloop versions.

## Installing Bloop

Bloop can be installed using Coursier:

```
$ coursier install bloop --only-prebuilt=true
```

For more details on installing Bloop, please see [Bloop's Installation Guide][install-guide]

## Upgrading

Upgrading can be done from Coursier:

```
$ coursier update bloop --only-prebuilt=true
```

## Merged pull requests

Here's a list of pull requests that were merged:
- Invoke done on sbt test runners [#1282]
- Fix ArchLinux package for v1.4+ [#1284]
- Fix local brew auto-completions installation [#1285]
- Fixes resolution errors with gradle-bloop [#1300]
- Update Maven Bloop Scala version to 2.12 [#1303]
- Bump websocket-extensions from 0.1.3 to 0.1.4 in `/website` [#1305]
- Add Scala Native environment setup guide to contributing guide [#1302]
- Fix binaries release on Windows [#1306]
- Make sure we try to revert to `JAVA_HOME` if java is not on `PATH` [#1310]
- Keep `compiledState` in `Interpreter.compileAnd` [#1307]
- Port bloop-config to Scala.js [#1299]
- Don't expand resource directory entries in BSP server [#1314]
- Fix bloopInstall in Maven when dirs don't exist [#1317]
- Workaround Windows publishing issue [#1316]
- Improve gradle dependency detection [#1313]
- Bump Zinc version [#1318]


[#1282]: https://github.com/scalacenter/bloop/pull/1282
[#1284]: https://github.com/scalacenter/bloop/pull/1284
[#1285]: https://github.com/scalacenter/bloop/pull/1285
[#1300]: https://github.com/scalacenter/bloop/pull/1300
[#1305]: https://github.com/scalacenter/bloop/pull/1305
[#1302]: https://github.com/scalacenter/bloop/pull/1302
[#1306]: https://github.com/scalacenter/bloop/pull/1306
[#1310]: https://github.com/scalacenter/bloop/pull/1310
[#1307]: https://github.com/scalacenter/bloop/pull/1307
[#1299]: https://github.com/scalacenter/bloop/pull/1299
[#1314]: https://github.com/scalacenter/bloop/pull/1314
[#1317]: https://github.com/scalacenter/bloop/pull/1317
[#1316]: https://github.com/scalacenter/bloop/pull/1316
[#1313]: https://github.com/scalacenter/bloop/pull/1313
[#1318]: https://github.com/scalacenter/bloop/pull/1318
[install-guide]: https://scalacenter.github.io/bloop/setup
